using System;
using System.Collections.Generic;
using System.Common;
using System.IRepositories;
using System.Linq;
using System.Model;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SqlSugar;
using TVShoppingCallCenter_ZLJ.Models.Inputs;

namespace TVShoppingCallCenter_ZLJ.Controllers.Traffic
{
    [Authorize]
    [Produces("application/json")]
    [Route("api/[controller]")]
    public class SetBlackListController : BaseController
    {
        private readonly ISys_CallBlacklistRepository _sys_callblacklistRepository;
        public SetBlackListController(ISys_CallBlacklistRepository sys_callblacklistRepository)
        {
            _sys_callblacklistRepository = sys_callblacklistRepository;
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="filter"></param>
        /// <returns></returns>
        [HttpGet("getlistbypage")]
        public async Task<IActionResult> GetListsByPage(string key, int pageindex = 1, int pagesize = 20)
        {
            List<IConditionalModel> conModels = new List<IConditionalModel>();
            #region 条件筛选
            conModels.Add(new ConditionalModel() { FieldName = "F_State", ConditionalType = ConditionalType.Equal, FieldValue = ((int)EnumDelState.Enabled).ToString() });
            if (!string.IsNullOrEmpty(key))
            {
                conModels.Add(new ConditionalCollections()
                {
                    ConditionalList = new List<KeyValuePair<WhereType, ConditionalModel>>()
                    {
                        new  KeyValuePair<WhereType, ConditionalModel>(WhereType.And, new ConditionalModel() { FieldName = "F_TelPhone", ConditionalType = ConditionalType.Like, FieldValue = key }),
                        new  KeyValuePair<WhereType, ConditionalModel>( WhereType.Or, new ConditionalModel() { FieldName = "F_Describe", ConditionalType = ConditionalType.Like, FieldValue = key })
                    }
                });
            }
            #endregion
            int recordCount = 0;
            var list = await _sys_callblacklistRepository.GetListByPage(conModels, new MyPageModel() { PageIndex = pageindex, PageSize = pagesize, PageCount = recordCount }, "F_CreateOn desc");

            return Success("成功", list);
        }

        /// <summary>
        /// 获取实体
        /// </summary>
        [HttpGet("getdetails")]
        public async Task<IActionResult> GetDetails(int id)
        {
            if (id <= 0)
                return Error("获取参数失败");
            var dModel = await _sys_callblacklistRepository.GetSingle(x => x.F_Id == id && x.F_State == (int)EnumDelState.Enabled);

            if (dModel != null)
            {
                return Success("获取成功", dModel);
            }
            else
            {
                return Error("获取失败");
            }
        }

        /// <summary>
        /// 添加
        /// </summary>
        [HttpPost("add")]
        public async Task<IActionResult> Add(CallBlackListInput input)
        {
            #region 验证
            if (string.IsNullOrWhiteSpace(input.telphone))
                return Error("拦截电话不能为空");
            if (input.removetime < input.settime)
                return Error("结束时间不能早于开始时间");
            #endregion
            T_Sys_CallBlacklist clmodel = new T_Sys_CallBlacklist();
            clmodel.F_TelPhone = input.telphone;
            clmodel.F_SetTime = input.settime;
            clmodel.F_RemoveTime = input.removetime;
            clmodel.F_Describe = input.describe;
            clmodel.F_InterceptNum = 0;

            clmodel.F_CreateBy = User.Claims.FirstOrDefault(c => c.Type == ClaimTypes.Sid).Value; //"8000";
            clmodel.F_CreateOn = DateTime.Now;
            clmodel.F_State = (int)EnumDelState.Enabled;

            var res = await _sys_callblacklistRepository.Add(clmodel);
            if (res > 0)
                return Success("保存成功");
            else
            {
                return Error("保存失败");
            }
        }

        /// <summary>
        /// 修改
        /// </summary>
        [HttpPost("update")]
        public async Task<IActionResult> Edit(CallBlackListInput input)
        {
            #region
            if (input.id <= 0)
                return Error("请选择要编辑的数据");
            if (string.IsNullOrWhiteSpace(input.telphone))
                return Error("拦截电话不能为空");
            if (input.removetime < input.settime)
                return Error("结束时间不能早于开始时间");
            #endregion

            var clmodel = await _sys_callblacklistRepository.GetSingle(x => x.F_Id == input.id && x.F_State == (int)EnumDelState.Enabled);
            if (clmodel == null)
                return Error("信息获取失败");
            clmodel.F_TelPhone = input.telphone;
            clmodel.F_SetTime = input.settime;
            clmodel.F_RemoveTime = input.removetime;
            clmodel.F_Describe = input.describe;

            clmodel.F_LastModifyBy = User.Claims.FirstOrDefault(c => c.Type == ClaimTypes.Sid).Value;
            clmodel.F_LastModifyOn = DateTime.Now;

            var res = await _sys_callblacklistRepository.Update(clmodel);

            if (res)
                return Success("保存成功");
            else
            {
                return Error("保存失败");
            }
        }

        [HttpPost("delete")]
        public async Task<IActionResult> Remove(int[] ids)
        {
            //使用逻辑删除
            //物理删除的数据无法恢复
            var res = 0;
            if (ids != null && ids.Length > 0)
            {
                foreach (var item in ids)
                {
                    var ml = await _sys_callblacklistRepository.GetSingle(x => x.F_Id == item);
                    ml.F_State = (int)EnumDelState.Delete;
                    ml.F_DeleteBy = User.Claims.FirstOrDefault(c => c.Type == ClaimTypes.Sid).Value;
                    ml.F_DeleteOn = DateTime.Now;
                    if (await _sys_callblacklistRepository.Update(ml))
                        res += 1;
                }
                if (res == ids.Length)
                    return Success("删除成功");
                else if (res > 0 && res < ids.Length)
                    return Error("部分删除失败，请查看后重新操作");
                else
                    return Error("删除失败，请查看后重新操作");
            }
            else
                return Error("请选择要删除的记录");
        }
    }
}